## net.i2p.data.i2np
Class DatabaseStoreMessage

    java.lang.Object
      net.i2p.data.DataStructureImpl
          net.i2p.data.i2np.I2NPMessageImpl
              net.i2p.data.i2np.DatabaseStoreMessage

All Implemented Interfaces:
  DataStructure, I2NPMessage

    public class DatabaseStoreMessage

extends I2NPMessageImpl

Defines the message a router sends to another router to test the network database reachability, as well as the reply message sent back.

Author:
  jrandom

Nested Class Summary

Nested classes/interfaces inherited from class net.i2p.data.i2np.I2NPMessageImpl
`I2NPMessageImpl.Builder`

Field Summary
`static int` `KEY_TYPE_LEASESET`
`static int` `KEY_TYPE_ROUTERINFO`
`static int` `MESSAGE_TYPE`

Fields inherited from class net.i2p.data.i2np.I2NPMessageImpl
`_context, CHECKSUM_LENGTH, DEFAULT_EXPIRATION_MS`

Fields inherited from interface net.i2p.data.i2np.I2NPMessage
`MAX_ID_VALUE, MAX_SIZE`

Constructor Summary
`DatabaseStoreMessage(I2PAppContext context)`

Method Summary
`protected int` `calculateWrittenLength()` calculate the message body's length (not including the header and footer
`boolean` `equals(java.lang.Object object)`
`Hash` `getKey()` Defines the key in the network database being stored
`LeaseSet` `getLeaseSet()` Defines the lease set value in the network database being stored
`Hash` `getReplyGateway()`
`long` `getReplyToken()` If a reply is desired, this token specifies the message ID that should be used for a DeliveryStatusMessage to be sent to the reply tunnel on the reply gateway.
`TunnelId` `getReplyTunnel()`
`RouterInfo` `getRouterInfo()` Defines the router info value in the network database being stored
`int` `getType()` Return the unique identifier for this type of I2NP message, as defined in the I2NP spec
`int` `getValueType()` Defines type of key being stored in the network database - either KEY_TYPE_ROUTERINFO or KEY_TYPE_LEASESET
`int` `hashCode()`
`void` `readMessage(byte[] data, int offset, int dataSize, int type)` Read the body into the data structures, after the initial type byte and the uniqueId / expiration, using the current class's format as defined by the I2NP specification
`void` `setKey(Hash key)`
`void` `setLeaseSet(LeaseSet leaseSet)`
`void` `setReplyGateway(Hash peer)`
`void` `setReplyToken(long token)` Update the reply token.
`void` `setReplyTunnel(TunnelId id)`
`void` `setRouterInfo(RouterInfo routerInfo)`
`void` `setValueType(int type)`
`java.lang.String` `toString()`
`protected int` `writeMessageBody(byte[] out, int curIndex)` write the message body to the output array, starting at the given index

Methods inherited from class net.i2p.data.i2np.I2NPMessageImpl
`createMessage, fromRawByteArray, fromRawByteArray, getMessageExpiration, getMessageSize, getRawMessageSize, getUniqueId, read, readBytes, readBytes, readBytes, readMessage, registerBuilder, setMessageExpiration, setUniqueId, toByteArray, toByteArray, toRawByteArray, verifyUnwritten, writeBytes, written`

Methods inherited from class net.i2p.data.DataStructureImpl
`calculateHash, fromBase64, fromByteArray, read, toBase64`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface net.i2p.data.DataStructure
`calculateHash, fromBase64, fromByteArray, toBase64`

Field Detail

### MESSAGE_TYPE

    public static final int MESSAGE_TYPE

See Also:
  Constant Field Values

### KEY_TYPE_ROUTERINFO

    public static final int KEY_TYPE_ROUTERINFO

See Also:
  Constant Field Values

### KEY_TYPE_LEASESET

    public static final int KEY_TYPE_LEASESET

See Also:
  Constant Field Values

Constructor Detail

### DatabaseStoreMessage

    public DatabaseStoreMessage(I2PAppContext context)

Method Detail

### getKey

    public Hash getKey()

  Defines the key in the network database being stored

### setKey

    public void setKey(Hash key)

### getRouterInfo

    public RouterInfo getRouterInfo()

  Defines the router info value in the network database being stored

### setRouterInfo

    public void setRouterInfo(RouterInfo routerInfo)

### getLeaseSet

    public LeaseSet getLeaseSet()

  Defines the lease set value in the network database being stored

### setLeaseSet

    public void setLeaseSet(LeaseSet leaseSet)

### getValueType

    public int getValueType()

  Defines type of key being stored in the network database - either KEY_TYPE_ROUTERINFO or KEY_TYPE_LEASESET

### setValueType

    public void setValueType(int type)

### getReplyToken

    public long getReplyToken()

  If a reply is desired, this token specifies the message ID that should be used for a DeliveryStatusMessage to be sent to the reply tunnel on the reply gateway.

  Returns:
    positive reply token ID, or 0 if no reply is necessary.

### setReplyToken

    public void setReplyToken(long token)
                       throws java.lang.IllegalArgumentException

  Update the reply token.

  Throws:
    `java.lang.IllegalArgumentException` - if the token is out of range (min=0, max=I2NPMessage.MAX_ID_VALUE)

### getReplyTunnel

    public TunnelId getReplyTunnel()

### setReplyTunnel

    public void setReplyTunnel(TunnelId id)

### getReplyGateway

    public Hash getReplyGateway()

### setReplyGateway

    public void setReplyGateway(Hash peer)

### readMessage

    public void readMessage(byte[] data,
                            int offset,
                            int dataSize,
                            int type)
                     throws I2NPMessageException,
                            java.io.IOException

  Description copied from interface: `I2NPMessage`
  Read the body into the data structures, after the initial type byte and the uniqueId / expiration, using the current class's format as defined by the I2NP specification

  Parameters:
    `data` - data to read from
    `offset` - where to start in the data array
    `dataSize` - how long into the data to read
    `type` - I2NP message type
  Throws:
    `I2NPMessageException` - if the stream doesn't contain a valid message that this class can read.
    `java.io.IOException` - if there is a problem reading from the stream

### calculateWrittenLength

    protected int calculateWrittenLength()

  calculate the message body's length (not including the header and footer

  Specified by:
    `calculateWrittenLength` in class `I2NPMessageImpl`

### writeMessageBody

    protected int writeMessageBody(byte[] out,
                                   int curIndex)
                            throws I2NPMessageException

  write the message body to the output array, starting at the given index

  Specified by:
    `writeMessageBody` in class `I2NPMessageImpl`
  Returns:
    the index into the array after the last byte written
  Throws:
    `I2NPMessageException`

### getType

    public int getType()

  Description copied from interface: `I2NPMessage`
  Return the unique identifier for this type of I2NP message, as defined in the I2NP spec

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `java.lang.Object`

### equals

    public boolean equals(java.lang.Object object)

  Overrides:
    `equals` in class `java.lang.Object`

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`